"""
    Kodi urlresolver plugin
    Copyright (C) 2014  smokdpi

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import re
import urllib
import urllib2
from t0mm0.common.net import Net
from urlresolver import common
from urlresolver.plugnplay import Plugin
from urlresolver.plugnplay.interfaces import UrlResolver
from urlresolver.plugnplay.interfaces import PluginSettings


class AaaaPlayVidResolver(Plugin, UrlResolver, PluginSettings):
    implements = [UrlResolver, PluginSettings]
    name = "si_playvid"
    domains = ["playvid.com", "playvids.com"]
    pattern = 'http://(.*?playvids*\.com)/(?:embed|watch/)(.+)'
    
    def __init__(self):
        self.set_setting('enabled', 'true')
        p = self.get_setting('priority') or 100
        self.priority = int(p)
        self.net = Net()
        self.user_agent = common.IE_USER_AGENT
        self.net.set_user_agent(self.user_agent)
        self.headers = {'User-Agent': self.user_agent}

    def get_url(self, host, media_id):
        return 'http://%s/embed/%s' % (host, media_id)

    def get_host_and_id(self, url):
        r = re.search(self.pattern, url)
        if r: return r.groups()
        else: return False

    def valid_url(self, url, host):
        return re.match(self.pattern, url) or self.name in host

    def get_media_url(self, host, media_id):
        web_url = self.get_url(host, media_id)
        self.headers['Referer'] = web_url
        html = self.net.http_GET(web_url, headers=self.headers).content
        r = re.search('<embed\s*(?:data-href-html5=".+?"\s*)?type="application/x-shockwave-flash"(.+?)/>', html)
        if r:
            s = urllib2.unquote(r.group(1).replace('&amp;', '&'))
            r = re.search('.*?video_vars\[video_url_default\]=(.+?)&.*', s)
            if r:
                r = re.search('.*?video_vars\[video_urls\]\[' + re.escape(r.group(1)) + '\]=(.+?)&.*', s)
                if r:
                    return r.group(1)
        raise UrlResolver.ResolverError('File not found')
